function [phi,dphi] = steifigkeit(s)
%s anzahl der Knoten an einer Seite

%schrittweite
h = 1/s;
%Anzahl Knoten
n = s^2;
%Anzahl innerer Knoten
n_inner = (s-2)^2;
%Anzahl Dreiecke
n_tri = 2*(s-1)^2;
%Triangulierungsmatrix
tri = [];


siz = [s,s];
for i = 1:s-1
	for j = 1:s-1
		%oberes Dreieck
		tri = [tri;sub2ind(siz,i+1,j),sub2ind(siz,i,j),sub2ind(siz,i+1,j+1)];
		%unteres Dreieck
		tri = [tri;sub2ind(siz,i,j+1),sub2ind(siz,i+1,j+1),sub2ind(siz,i,j)];
	end
end

phi = sparse(zeros(n));
dphi = sparse(zeros(n));

%Schleife über alle Dreiecke, Rand wird später entfernt, Vielfache von 1/24
for i = 1:n_tri

	%Diagonalelemente
	idx = sub2ind(size(phi),tri(i,1),tri(i,1));
	phi(idx) = phi(idx) + 2;
	dphi(idx)=dphi(idx) + 24;
	idx = sub2ind(size(phi),tri(i,2),tri(i,2));
	phi(idx) = phi(idx) + 2;
	dphi(idx)=dphi(idx) + 12;
	idx = sub2ind(size(phi),tri(i,3),tri(i,3));
	phi(idx) = phi(idx) + 2;
	dphi(idx)=dphi(idx) + 12;
	
	%Nebendiagonal
	idx = sub2ind(size(phi),tri(i,1),tri(i,2));
	phi(idx) = phi(idx) + 1;
	dphi(idx)=dphi(idx) - 12;
	idx = sub2ind(size(phi),tri(i,2),tri(i,1));
	phi(idx) = phi(idx) + 1;
	dphi(idx)=dphi(idx) - 12;

	idx = sub2ind(size(phi),tri(i,1),tri(i,3));
	phi(idx) = phi(idx) + 1;
	dphi(idx)=dphi(idx) - 12;
	idx = sub2ind(size(phi),tri(i,3),tri(i,1));
	phi(idx) = phi(idx) + 1;
	dphi(idx)=dphi(idx) - 12; 

	idx = sub2ind(size(phi),tri(i,2),tri(i,3));
	phi(idx) = phi(idx) + 1;
	dphi(idx)=dphi(idx) + 0;
	idx = sub2ind(size(phi),tri(i,3),tri(i,2));
	phi(idx) = phi(idx) + 1;
	dphi(idx)=dphi(idx) + 0;

end

%Randelemente entfernen
marker = true(s);
marker(1,:) = false;
marker(s,:) = false;
marker(:,1) = false;
marker(:,s) = false;

%Indizes aller innerer Knoten
idx = find(marker);

%Skalierung
phi = phi(idx,idx)/24*h^2;
dphi = dphi(idx,idx)/24;

